<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://myworks.design/
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/admin/partials
 */
?>
<?php
	global $MWQDC_LB;
	global $wpdb;
	$page_url = 'admin.php?page=mw-qbo-desktop-map&tab=shipping-method';
	
	$wc_sh_methods = WC()->shipping->load_shipping_methods();
	
	if ( ! empty( $_POST ) && check_admin_referer( 'myworks_wc_qbo_sync_map_wc_qbo_shipping_method_desk', 'map_wc_qbo_shipping_method_desk' ) ) {
		$item_ids = array();
		foreach ($_POST as $key=>$value){
			if ($MWQDC_LB->start_with($key, "map_shipping_method_")){
				$id = str_replace("map_shipping_method_", "", $key);
				$id = trim($id);
				if($id!='' && is_array($wc_sh_methods) && isset($wc_sh_methods[$id])){
					$item_ids[$id] = $value;
				}
			}
		}
		
		if(count($item_ids)){
			foreach ($item_ids as $key=>$value){
				$save_data = array();			
				$save_data['qbo_product_id'] = $value;
				$save_data['class_id'] = (isset($_POST['class_map_shipping_method_'.$key]))?$_POST['class_map_shipping_method_'.$key]:'';
				
				$table = $wpdb->prefix.'mw_wc_qbo_desk_qbd_map_shipping_product';
				if($MWQDC_LB->get_field_by_val($table,'id','wc_shippingmethod',$key)){
					$wpdb->update($table,$save_data,array('wc_shippingmethod'=>$key),'',array('%s'));
				}else{
					$save_data['wc_shippingmethod'] = $key;
					$wpdb->insert($table, $save_data);
				}
			}
			$MWQDC_LB->set_session_val('map_page_update_message',__('Shipping methods mapped successfully.','mw_wc_qbo_desk'));
		}
		$MWQDC_LB->redirect($page_url);
	}
	
	$qbo_product_options = '';
	if(!$MWQDC_LB->option_checked('mw_wc_qbo_desk_select2_ajax')){
		$qbo_product_options = $MWQDC_LB->option_html('', $wpdb->prefix.'mw_wc_qbo_desk_qbd_items','qbd_id','name','','name ASC','',true);
	}
	
	$qbo_class_options_value = $MWQDC_LB->option_html('', $wpdb->prefix.'mw_wc_qbo_desk_qbd_list_class','qbd_id','name','','name ASC','',true);
	$qbo_class_options = '<option value=""></option>';	
	$qbo_class_options.= ''.$qbo_class_options_value;

	$selected_options_script = '';
	$sm_map_data = $MWQDC_LB->get_tbl($wpdb->prefix.'mw_wc_qbo_desk_qbd_map_shipping_product');
	$sm_map_data_kv_arr = array();
	if(is_array($sm_map_data) && count($sm_map_data)){
		foreach($sm_map_data as $sm_k=>$sm_val){
			if(!$MWQDC_LB->option_checked('mw_wc_qbo_desk_select2_ajax')){
				$selected_options_script.='jQuery(\'#map_shipping_method_'.$sm_val['wc_shippingmethod'].'\').val(\''.$sm_val['qbo_product_id'].'\');';
			}else{
				$sm_map_data_kv_arr[$sm_val['wc_shippingmethod']] = $sm_val['qbo_product_id'];
			}			
			$selected_options_script.='jQuery(\'#class_map_shipping_method_'.$sm_val['wc_shippingmethod'].'\').val(\''.$sm_val['class_id'].'\');';
		}	
	}
?>
<?php require_once plugin_dir_path( __FILE__ ) . 'mw-qbo-desktop-admin-menu-map-nav.php';?>
<div class="container map-shipping-method-outer">
	<div class="page_title"><h4><?php _e( 'Shipping Method Mappings', 'mw_wc_qbo_desk' );?></h4></div>
	<div class="card">
		<div class="card-content">
			<div class="row">
			<?php if(is_array($wc_sh_methods) && count($wc_sh_methods)):?>
				<form method="POST" class="col s12 m12 l12" action="<?php echo $page_url;?>">
					<div class="row">
						<div class="col s12 m12 l12">
							<table class="mw-qbo-sync-map-table menu-blue-bg" width="100%">	
                            	<thead>				
                                    <tr>
                                        <th width="50%" class="title-description">
                                            Woocommerce Shipping Method								    	
                                        </th>
                                        <th width="25%" class="title-description">
                                            Quickbooks Product								    	
                                        </th>
                                        <th width="25%" class="title-description">
                                            Quickbooks Class
                                        </th>
                                    </tr>
                                 </thead>   
								<?php foreach($wc_sh_methods as $sm_key => $sm_val):?>
								<tr>
									<td>
									<b><?php echo $sm_val->method_title;?></b> (<?php echo $sm_key;?>)
									<p><?php echo stripslashes(strip_tags($sm_val->method_description));?></p>
									</td>
									<td>
										<?php
											$dd_options = '<option value=""></option>';
											$dd_ext_class = '';
											if($MWQDC_LB->option_checked('mw_wc_qbo_desk_select2_ajax')){
												$dd_ext_class = 'mwqs_dynamic_select_desk';
												if(count($sm_map_data_kv_arr) && isset($sm_map_data_kv_arr[$sm_key]) && $sm_map_data_kv_arr[$sm_key]!=''){
													$itemid = $sm_map_data_kv_arr[$sm_key];
													$qb_item_name = $MWQDC_LB->get_field_by_val($wpdb->prefix.'mw_wc_qbo_desk_qbd_items','name','qbd_id',$itemid);
													if($qb_item_name!=''){
														$dd_options = '<option value="'.$itemid.'">'.$qb_item_name.'</option>';
													}
												}
											}else{
												$dd_options.=$qbo_product_options;
											}
										?>
										<select class="mw_wc_qbo_sync_select2_desk <?php echo $dd_ext_class;?>" name="map_shipping_method_<?php echo $sm_key?>" id="map_shipping_method_<?php echo $sm_key?>">
											<?php echo $dd_options;?>
										</select>
									</td>
									<td>
										<select class="mw_wc_qbo_sync_select2_desk" name="class_map_shipping_method_<?php echo $sm_key?>" id="class_map_shipping_method_<?php echo $sm_key?>">
											<?php echo $qbo_class_options;?>
										</select>
									</td>
								</tr>
								<?php endforeach;?>							
							</table>
						</div>
					</div>
					<div class="row">
						<?php wp_nonce_field( 'myworks_wc_qbo_sync_map_wc_qbo_shipping_method_desk', 'map_wc_qbo_shipping_method_desk' ); ?>
						<div class="input-field col s12 m6 l4">
							<button class="waves-effect waves-light btn save-btn mw-qbo-sync-green">Save</button>
						</div>
					</div>
				</form>
			<?php else:?>
				<p><?php _e( 'No shipping method found.', 'mw_wc_qbo_desk' );?></p>
			<?php endif;?>
			</div>
		</div>
	</div>
</div>
<?php if($selected_options_script!=''):?>
<script type="text/javascript">
jQuery(document).ready(function(){
	<?php echo $selected_options_script;?>
});
</script>
<?php endif;?>
<?php echo $MWQDC_LB->get_select2_js('.mw_wc_qbo_sync_select2_desk','qbo_product');?>